
local shadow = { }

function Relegation:AddFrame(name)
	local function OnEvent(frame, event, ...)
		shadow[frame][event](...)
	end
	
	local frame = CreateFrame("Frame")
	
	self.frames[name] = {
		["events"] = { },
		["frame"]  = frame,
	}
	
	shadow[frame] = { }
	
	frame:SetScript("OnEvent", OnEvent)
	
	setmetatable(self.frames[name].events, {
		["__index"] = function (self, key)
			return shadow[frame][key]
		end,
		["__newindex"] = function (self, key, value)
			if (value) then
				frame:RegisterEvent(key)
			else
				frame:UnregisterEvent(key)
			end
			
			shadow[frame][key] = value
		end,
	})
end

